"""system_parameter logo image

Revision ID: 02f3eeec36ea
Revises: 47332b7ff542
Create Date: 2017-11-21 22:03:58.289802

"""
from alembic import op
import sqlalchemy as sa
import falcon_rest
import api_dnl



# revision identifiers, used by Alembic.
revision = '02f3eeec36ea'
down_revision = '47332b7ff542'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_index('ix_balance_history_actual_date', table_name='balance_history_actual')
    op.create_index('ix_balance_history_actual_date', 'balance_history_actual', ['date', 'client_id'], unique=True)
    op.add_column('send_rate_template', sa.Column('to_mail', sa.String(length=200), nullable=True))
    op.add_column('system_parameter', sa.Column('logo_image_id', sa.Integer(), nullable=True))
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column('system_parameter', 'logo_image_id')
    op.drop_column('send_rate_template', 'to_mail')
    op.drop_index('ix_balance_history_actual_date', table_name='balance_history_actual')
    op.create_index('ix_balance_history_actual_date', 'balance_history_actual', ['date'], unique=False)
    # ### end Alembic commands ###
