# coding: utf-8

"""
    DNL API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.3.44
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import cli_dnl
from cli_dnl.rest import ApiException
from cli_dnl.apis.auth_api import AuthApi
from .settings import *

def user(**kwargs):
    if 'user_type' in kwargs:
        typ=kwargs['user_type']
    else:
        typ='user'
    name=bla(8)
    data = {'email': bla_mail(),
        'active': get_rand('bool'),
        'all_termination': get_rand('bool'),
        'avatar_id':rand_import(obj='png')[0],
        'card_id': get_rand('int'),
        #'client_id': rand_client()[0],
        'default_mod': bla(8),
        'default_mod2': bla(8),
        'first_name': name,
        'last_name': bla(5),
        'landing_page': bla(4),
        'auth_ip': [{'ip':ip(check_dublicates=False)},{'ip':ip(check_dublicates=False)}],
        'name': typ+'_'+name,
        'outbound_report': get_rand('bool'),
        'passwd': bla(4),
        'report_fields': bla(4),
        'report_group': get_rand('bool'),
        'reseller_id': rand_agent()[0] ,
        'role_id': random.choice([0, 1,2]),
        'show_carrier_trunk_drop_only': get_rand('bool'),
        'user_type': random.choice(['admin', 'client', 'agent']),
        'client_limits': [{'client_id': rand_client()[0]}]
    }
    for a in kwargs:
        data[a]=kwargs[a]
    return data


class TestAuthApi(unittest.TestCase):
    """ AuthApi unit test stubs """

    def setUp(self):
        self.api = cli_dnl.apis.auth_api.AuthApi()

    def tearDown(self):
        pass

    def test_auth_as_agent_post(self):
        """
        Test case for auth_as_agent_post


        """
        auth()
        id = rand_agent()[0]
        ret = self.api.auth_as_agent_post(body={'agent_id': id})
        assert (ret.success)
        print(ret)
        pass

    def test_auth_as_client_post(self):
        """
        Test case for auth_as_client_post

        
        """

        auth()
        id=rand_client(status=True)[0]
        #id = 3682
        ret=self.api.auth_as_client_post(body={'client_id':id})
        assert (ret.success)
        print (ret)
        pass

    def test_auth_check_password_post(self):
        """
        Test case for auth_check_password_post

        
        """
        pass

    def test_auth_check_token_post(self):
        """
        Test case for auth_check_token_post

        
        """
        pass

    def test_auth_post(self):
        """
        Test case for auth_post

        
        """
        r=self.api.auth_post(body=dict(email_or_name='admin',password='yoo5Iche'))
        print(r)
        assert (r.success)
        #assert(r.payload.user.default_billing_decimal != None)
        pass

    def test_auth_reset_email_post(self):
        """
        Test case for auth_reset_email_post

        
        """
        auth()
        host = cli_dnl.configuration.host
        u=rand_user(email='_novvv@mail.ru')[1]
        print(u)
        ret=self.api.auth_reset_email_post(body={'name':u.name })
        assert(ret.success)
        pass

    def test_auth_reset_token_post(self):
        """
        Test case for auth_reset_token_post

        
        """
        auth(2751)#icxuser
        # auth(2693)#soupra
        # auth(2676)#egress
        # auth(2678)#Akash22
        # auth(2675)#Ingress
        auth(2755)#agent
        # auth(2533)
        # auth(2487)
        auth(1)

        pass

    def test_auth_session_list_get(self):
        """
        Test case for auth_session_list_get


        """
        auth()
        ret=self.api.auth_session_list_get()
        assert(ret.success)
        print (ret)
        pass

    def test_registration_all_delete(self):
        """
        Test case for registration_all_delete


        """
        pass

    def test_registration_create_post(self):
        """
        Test case for registration_create_post

        
        """
        auth()
        a = rand_agent()[1]
        aname=a.agent_name
        print(aname)
        key = a.referal_key
        print('key', key)

        auth()
        lst = self.api.registration_list_get(main_email='_novvv@mail.ru')
        assert (lst.success)
        if len(lst.payload.items):
            self.api.registration_id_delete(id=lst.payload.items[0].id)
            pass
        lst=self.api.user_list_get(email='_novvv@mail.ru')
        assert (lst.success)
        if len(lst.payload.items):
            self.api.user_user_id_delete(user_id=lst.payload.items[0].user_id)
        email = '_novvv@mail.ru'
        data = { 'phone': dig(7), 'address': bla(), 'status': random.choice([True, False]),
                 'username': bla(6),'client_name':bla(7),
                 'last_name': bla(6),'company':bla_comp(),
                 'main_email': email, 'password': bla(8),
                 'company_detail':lorem_ipsum(),
                 'phone':dig(9),
                 'send_signup_notification':1,
                 'ip_address':[{'ip':ip(False),'mask':1,'port':1234}],
                 'referral':key
                 }
        print('POST/registration/create',json.dumps(data))

        ret=self.api.registration_create_post(body=data)
        assert (ret.success)
        print(ret)
        ret1=self.api.registration_list_get(id_in=str(ret.object_id))
        assert(ret1.payload.items[0].referral_name==aname)
        return ret
        try:
            ret = self.api.registration_create_post(body=data)
            assert (not ret.success)
        except Exception as e:
            assert ('already_exists' in str(e))
        data['main_email']=bla_mail()
        cl=rand_client()[1]
        data['client_name'] = cl.name
        try:
            ret = self.api.registration_create_post(body=data)
            assert (not ret.success)
        except Exception as e:
            assert ('already_exists' in str(e))

        data['client_name'] = 'cli_reg_'+bla(8)
        us=rand_user()[1]
        data['username'] = us.name
        try:
            ret = self.api.registration_create_post(body=data)
            assert (not ret.success)
        except Exception as e:
            assert ('already_exists' in str(e))

        return ret

        pass

    def test_registration_get_referal_name_referal_key_get(self):
        """
        Test case for registration_get_referal_name_referal_key_get


        """
        auth()
        a=rand_agent()[1]
        print(a.agent_name)
        key=a.referal_key
        print('key',key)
        ret = self.api.registration_get_referal_name_referal_key_get(referal_key=key)
        print(ret)

        pass

    def test_registration_id_approve_patch(self):
        """
        Test case for registration_id_approve_patch

        
        """
        auth()
        ret=self.test_registration_create_post()
        ret=self.api.registration_id_approve_patch(id=ret.object_id,body={'status':'approved'})
        assert(ret.success)
        pass

    def test_registration_id_delete(self):
        """
        Test case for registration_id_delete

        
        """
        auth()
        ret = self.test_registration_create_post()
        self.api.registration_id_delete(id=ret.object_id)
        pass

    def test_registration_id_get(self):
        """
        Test case for registration_id_get

        
        """
        auth()
        ret = self.test_registration_create_post()
        self.api.registration_id_get(id=ret.object_id)
        pass

    def test_registration_id_patch(self):
        """
        Test case for registration_id_patch

        
        """
        auth()
        ret=self.api.registration_list_get()
        reg=random.choice(ret.payload.items)
        try:
            ret=self.api.registration_id_patch(id=reg.id,body={'main_email':'_novvv@mail.ru'})
        except Exception as e:
            assert('already' in str(e))
        #ret = self.api.registration_id_patch(id=reg.id, body={'rate_send_to_email': bla_mail() })
        #assert(ret.success)

        pass

    def test_registration_list_get(self):
        """
        Test case for registration_list_get

        
        """
        auth()
        ret = self.api.registration_list_get()
        assert(ret.success)
        pass

    def test_ticket_comment_id_attach_post(self):
        """
        Test case for ticket_comment_id_attach_post


        """
        pass

    def test_ticket_comment_id_delete(self):
        """
        Test case for ticket_comment_id_delete


        """
        pass

    def test_ticket_comment_id_get(self):
        """
        Test case for ticket_comment_id_get


        """
        pass

    def test_ticket_comment_id_patch(self):
        """
        Test case for ticket_comment_id_patch


        """
        pass

    def test_ticket_comment_id_send_patch(self):
        """
        Test case for ticket_comment_id_send_patch


        """
        pass

    def test_ticket_create_post(self):
        """
        Test case for ticket_create_post


        """
        auth()
        my_ip=ip()
        auth_random_a()
        data = dict(gateway_ip=my_ip, subject=bla_bla(3), content=bla_bla(15), department='NOC')
        ret = self.api.ticket_create_post(body=data)
        assert (ret.success)
        auth_random_c()
        data =dict(gateway_ip='1.2.3.4',subject=bla_bla(3),content=bla_bla(15),department='NOC')
        ret=self.api.ticket_create_post(body=data)
        assert(ret.success)
        return ret
        pass

    def test_ticket_file_uuid_delete(self):
        """
        Test case for ticket_file_uuid_delete


        """
        auth()
        ret = self.api.ticket_list_get()
        assert (ret.success and len(ret.payload.items))
        file = 'api_dnl/test/data/1.png'
        ret = self.api.ticket_id_attach_post(id=ret.payload.items[0].id, file=file)
        assert (ret.success)
        ret = self.api.ticket_file_uuid_delete(uuid=ret.object_uuid)
        assert (ret.success)
        print(ret)
        pass

    def test_ticket_file_uuid_get(self):
        """
        Test case for ticket_file_uuid_get


        """
        pass

    def test_ticket_id_attach_post(self):
        """
        Test case for ticket_id_attach_post


        """
        auth()
        ret = self.api.ticket_list_get()
        assert (ret.success and len(ret.payload.items))
        file='api_dnl/test/data/1.png'
        ret = self.api.ticket_id_attach_post(id=ret.payload.items[0].id, file=file)
        assert(ret.success)
        print(ret)
        pass

    def test_ticket_id_comment_create_post(self):
        """
        Test case for ticket_id_comment_create_post


        """
        auth()
        id = rand_ticket()[0]
        data = dict(subject='subj '+bla(7), content='cont '+lorem_ipsum(),url='http://example.org')
        ret = self.api.ticket_id_comment_create_post(id=id,body=data)
        assert (ret.success)
        print (id,ret)

        auth_random_c()
        data = dict(gateway_ip='1.2.3.4', subject='subj '+ bla(8) , content=bla_bla(5), department='NOC')
        ret = self.api.ticket_create_post(body=data)
        assert (ret.success)
        id = ret.object_id
        data = dict(subject='subj ' + bla(7), content='cont ' + lorem_ipsum(), url='http://{}.org'.format(bla(7)))
        ret = self.api.ticket_id_comment_create_post(id=id, body=data)
        assert (ret.success)
        print(id, ret)
        data = dict(subject='subj ' + bla(7), content='cont ' + lorem_ipsum(), url='http://{}.org'.format(bla(7)))
        ret = self.api.ticket_id_comment_create_post(id=id, body=data)
        assert (ret.success)
        print(id, ret)

        pass

    def test_ticket_id_delete(self):
        """
        Test case for ticket_id_delete


        """
        pass

    def test_ticket_id_get(self):
        """
        Test case for ticket_id_get


        """
        auth_random_c()
        ret = self.api.ticket_list_get()
        assert (ret.success)
        if len(ret.payload.items):
            ret = self.api.ticket_id_get(id=ret.payload.items[0].ticket_id)
        assert (ret.success)
        print(ret)

        pass

    def test_ticket_id_patch(self):
        """
        Test case for ticket_id_patch


        """
        pass

    def test_ticket_id_create_and_send_patch(self):
        auth_random_c()
        dep=random.choice(['Admin','Finance','NOC'])
        data = dict(gateway_ip='1.2.3.4', subject='subj', content=lorem_ipsum(), department=dep)
        ret = self.api.ticket_create_post(body=data)
        assert (ret.success)
        ret = self.api.ticket_id_send_patch(id=ret.object_id)
        assert (ret.success)
        print(dep,ret)

    def test_ticket_id_send_patch(self):
        """
        Test case for ticket_id_send_patch


        """
        auth_random_c()
        id = rand_ticket()[0]
        ret = self.api.ticket_id_send_patch(id=id)
        assert (ret.success)
        print(ret)
        pass

    def test_ticket_list_get(self):
        """
        Test case for ticket_list_get


        """
        auth()
        ret=self.api.ticket_list_get()
        assert (ret.success)
        print(ret)
        pass

    def test_user_all_delete(self):
        """
        Test case for user_all_delete


        """
        auth()
        ret=self.api.user_all_delete(name='X*')
        assert(ret.success)
        print(ret)
        pass

    def test_user_all_patch(self):
        """
        Test case for user_all_patch


        """
        auth()
        ret = self.api.user_all_patch(name='user_A007*',body={'active':False})
        assert (ret.success)
        print(ret)
        pass

    def test_user_create_post(self):
        """
        Test case for user_create_post

        
        """
        auth()
        for u in ('client',):
        #for u in('admin','agent','client'):
            data=user(user_type=u,passwd='123')
            if u=='client':
                data['email']='_novvv@mail.ru'
                data['client_id'] = rand_client()[0]
                data['client']={'carrier_name':bla(10)+dig(5),'is_panelaccess':True}
            ret=self.api.user_create_post(body=data)
            assert(ret.success)
            print(json.dumps(data))
            print(ret)
        pass

    def test_user_get(self):
        """
        Test case for user_get

        
        """
        auth()
        ret=cli_dnl.ConfigApi().config_system_patch(body={'inactivity_timeout':1})
        assert(ret.success)
        auth_random_c()
        sleep(65)
        try:
            ret = self.api.user_get()
            assert (not ret.success)
        except Exception as e:
            assert('token_expired' in str(e))
        auth()
        ret = cli_dnl.ConfigApi().config_system_patch(body={'inactivity_timeout': 60*24*7})
        assert (ret.success)

        auth_random_c()
        sleep(65)
        ret=self.api.user_get()
        assert(ret.success)

        auth_random_a()
        ret = self.api.user_get()
        assert (ret.success)

        pass

    def test_user_list_get(self):
        """
        Test case for user_list_get

        
        """
        auth()
        ret= self.api.user_list_get(name='*adm*',per_page=100)
        assert(ret.success)

        print(','.join([u.name for u in ret.payload.items]))
        pass

    def test_user_patch(self):
        """
        Test case for user_patch


        """
        pass

    def test_user_user_id_delete(self):
        """
        Test case for user_user_id_delete

        
        """
        pass

    def test_user_user_id_get(self):
        """
        Test case for user_user_id_get

        
        """
        pass

    def test_user_user_id_patch_client(self):
        """
        Test case for user_user_id_patch


        """

        auth()
        ul = self.api.user_list_get(user_type='client').payload.items
        random.shuffle(ul)
        cl = rand_client()[0]
        print(cl,ul[0])
        ret = self.api.user_user_id_patch(user_id=ul[0].user_id, body={'client_id':cl,'client':{'is_panelaccess':False}})
        assert (ret.success)
        print (ret)


    def test_user_user_id_patch(self):
        """
        Test case for user_user_id_patch

        
        """

        auth()
        avt = rand_import(obj='png')[0]
        data={'passwd': 'yoo5Iche',
         'avatar_id': avt, 'first_name': bla(6), 'last_name':bla(6)}

        ret = self.api.user_user_id_patch(user_id=rand_user()[0], body=data)
        assert (ret.success)


        ret=cli_dnl.CarrierApi().carrier_list_get()
        cli=[]
        assert(ret.success)
        for i in range(0,4):
            cli.append({'client_id':random.choice(ret.payload.items).client_id})
        assert (ret.success)
        avt = rand_import(obj='png')[0]
        ret=self.api.user_user_id_patch(user_id=rand_user()[0],body={'client_limits':cli,'avatar_id':avt})
        assert (ret.success)
        assert(ret.payload.client_limits[0].client_id in [d['client_id'] for d in cli])
        pass


if __name__ == '__main__':
    unittest.main()
