# coding: utf-8

"""
    DNL API

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.4.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import os
import sys
import unittest

import cli_dnl
from cli_dnl.rest import ApiException
from cli_dnl.apis.monitoring_api import MonitoringApi
from .settings import *

class TestMonitoringApi(unittest.TestCase):
    """ MonitoringApi unit test stubs """

    def setUp(self):
        self.api = cli_dnl.apis.monitoring_api.MonitoringApi()
        auth()

    def tearDown(self):
        pass

    def test_monitoring_fraud_detection_all_delete(self):
        """
        Test case for monitoring_fraud_detection_all_delete


        """
        pass

    def test_monitoring_fraud_detection_all_patch(self):
        """
        Test case for monitoring_fraud_detection_all_patch


        """
        pass

    def test_monitoring_fraud_detection_id_delete(self):
        """
        Test case for monitoring_fraud_detection_id_delete

        
        """
        ret0 = self.test_monitoring_fraud_detection_post()
        ret = self.api.monitoring_fraud_detection_id_delete(id=ret0.object_id)
        assert (ret.success)
        pass

    def test_monitoring_fraud_detection_id_get(self):
        """
        Test case for monitoring_fraud_detection_id_get

        
        """
        ret0 = self.test_monitoring_fraud_detection_post()
        ret = self.api.monitoring_fraud_detection_id_get(id=ret0.object_id)
        assert (ret.success)
        pass

    def test_monitoring_fraud_detection_id_patch(self):
        """
        Test case for monitoring_fraud_detection_id_patch

        
        """
        ls = rand_trunk(direction='ingress', per_page=300)[2]
        random.shuffle(ls)
        tr = [t.trunk_id for t in ls[0:6]]
        data = {
            'enable_block': get_rand('bool'),
            'one_hour_revenue': 10,
            'one_hour_duration': 20,
            'active': get_rand('bool'),
            'name': 'fraud_' + bla(8),
            'enable_email': get_rand('bool'),
            'hour_24_revenue': 10,
            'hour_24_duration': 20,
            'ingress_trunks': tr,
            'email_to': random.choice(['Own NOC Email', 'Partner NOC Email', 'Both'])
        }
        ret0 = self.test_monitoring_fraud_detection_post()
        ret = self.api.monitoring_fraud_detection_id_patch(id=ret0.object_id,body=data)
        assert (ret.success)
        pass

    def test_monitoring_fraud_detection_list_get(self):
        """
        Test case for monitoring_fraud_detection_list_get

        
        """
        for order in ['active','name','enable_block','update_by','enable_email','email_to',
                         'name', 'one_hour_duration', 'one_hour_revenue',
                         'hour_24_duration', 'hour_24_revenue','update_on']:
            for dir in ['asc','desc']:
                ret = self.api.monitoring_fraud_detection_list_get(order_by=order,order_dir=dir)
                assert(ret.success)

        pass

    def test_monitoring_fraud_detection_post(self):
        """
        Test case for monitoring_fraud_detection_post

        
        """
        ls=rand_trunk(direction='ingress',per_page=300)[2]
        random.shuffle(ls)
        tr=[t.trunk_id for t in ls[0:6]]

        data = {
  'enable_block': get_rand('bool'),
  'one_hour_revenue': 10,
  'one_hour_duration': 20,
  'active': get_rand('bool'),
  'name': 'fraud_'+bla(8),
  'enable_email': get_rand('bool'),
  'hour_24_revenue': 10,
  'hour_24_duration': 20,
  'ingress_trunks': tr,
  'email_to': random.choice(['Own NOC Email','Partner NOC Email', 'Both'])
}
        ret=self.api.monitoring_fraud_detection_post(body=data)
        assert(ret.success)
        return ret
        pass

    def test_monitoring_loop_detection_all_delete(self):
        """
        Test case for monitoring_loop_detection_all_delete


        """
        pass

    def test_monitoring_loop_detection_all_patch(self):
        """
        Test case for monitoring_loop_detection_all_patch


        """
        pass

    def test_monitoring_loop_detection_blocked_get(self):
        """
        Test case for monitoring_loop_detection_blocked_get


        """
        auth()
        ret=self.api.monitoring_loop_detection_blocked_get()
        assert (ret.success)
        print(ret)
        pass

    def test_monitoring_loop_detection_id_delete(self):
        """
        Test case for monitoring_loop_detection_id_delete

        
        """


        pass

    def test_monitoring_loop_detection_id_get(self):
        """
        Test case for monitoring_loop_detection_id_get

        
        """
        pass

    def test_monitoring_loop_detection_id_patch(self):
        """
        Test case for monitoring_loop_detection_id_patch

        
        """
        pass

    def test_monitoring_loop_detection_list_get(self):
        """
        Test case for monitoring_loop_detection_list_get

        
        """
        ret = self.api.monitoring_loop_detection_list_get(trunk_count_gt=2,trunk_count_lt=4)
        assert (ret.success)
        print(len(ret.payload.items))
        ret=self.api.monitoring_loop_detection_list_get(order_by='trunk_count',order_dir='desc')
        assert (ret.success)

        pass

    def test_monitoring_loop_detection_post(self):
        """
        Test case for monitoring_loop_detection_post

        
        """
        pass

    def test_monitoring_rule_all_delete(self):
        """
        Test case for monitoring_rule_all_delete


        """
        pass

    def test_monitoring_rule_all_patch(self):
        """
        Test case for monitoring_rule_all_patch


        """
        pass

    def test_monitoring_rule_id_delete(self):
        """
        Test case for monitoring_rule_id_delete

        
        """
        pass

    def test_monitoring_rule_id_get(self):
        """
        Test case for monitoring_rule_id_get

        
        """
        ret=self.test_monitoring_rule_post()
        pass

    def test_monitoring_rule_id_patch(self):
        """
        Test case for monitoring_rule_id_patch

        
        """
        pass

    def test_monitoring_rule_list_get(self):
        """
        Test case for monitoring_rule_list_get

        
        """
        for order in ['name','activate','block','update_at','update_by','last_run_time',
                      'next_run_time']:
            for dir in ['asc','desc']:
                ret = self.api.monitoring_rule_list_get(order_by=order,order_dir=dir)
                assert(ret.success)
        pass

    def test_monitoring_rule_post(self):
        """
        Test case for monitoring_rule_post

        
        """
        tr=rand_trunk(per_page=200)[2]
        random.shuffle(tr)
        trunks=[t.trunk_id for t in tr[0:5]]

        data = {
  'run_day_of_week': random.choice(
                  ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday']),
  'monitor_by': random.choice(['Trunk','Trunk And DNIS', 'Trunk And ANI', 'DNIS','ANI','Trunk And Destination', 'Trunk And Country', 'Trunk And Code']),
  'profitability_operator': '1',
  'asr_operator': '1',
  'min_attempt': random.randint(0,6),
  'pdd_operator': '1',
  'revenue_operator': '1',
  'block': get_rand('bool'),
  'monitor_ingress': get_rand('bool'),
  'exclude_codes': [0,1,2,3],
  'pdd_value': random.randint(0,6),
  'all_trunks': get_rand('bool'),
  'subject': bla_bla(3),
  'asr_value': random.randint(0,6),
  'activate': get_rand('bool'),
  'trunks': trunks,
  'auto_unblock_after': random.randint(0,6),
  'revenue_value': random.randint(0,6),
  'auto_unblock': get_rand('bool'),
  'acd_operator': '1',
  'name': 'monitoring_rule_'+bla(8),
  'html_content': lorem_ipsum(),
  'scope': random.choice(['Disable Entire Trunk','Disable Specific Code','Disable Specific Code Name']),
  'schedule': random.choice(['never','Every Specific Minutes','Daily','Weekly']),
  'run_on': random.randint(0,6),
  'acd_value': random.randint(0,6),
  'profitability_value': random.randint(0,6),
  'sample_period': random.randint(0,6),
  'run_every': random.randint(0,6),
  'from_mail_id': rand_mail_sender()[0],
  'send_email': get_rand('bool'),
  'send_to': random.choice(['Own NOC Email','Partner NOC Email','Both']),
  'include':random.choice(['All Codes','Specific Codes','Specific Code Names']),
  'exclude': random.choice(['None', 'Specific Codes', 'Specific Code Names']),
  'sdp_sign':random.choice(['ignore', '=', '<','>']),
  'sdp_stype': random.choice(['none', '6sec', '12sec', '18sec', '24sec', '30sec']),
  'sdp_value': random.randint(0,6),
}
        if data['include'] ==  'Specific Codes':
            data['include_codes']=[123,345,456]
        if data['include'] ==  'Specific Code Names':
            data['in_code_name_id']=123
        if data['exclude'] ==  'Specific Codes':
            data['exclude_codes']=[123,345,456]
        if data['exclude'] ==  'Specific Code Names':
            data['ex_code_name_id']=123

        ret=self.api.monitoring_rule_post(body=data)
        assert(ret.success)
        print(data)
        return ret
        pass

if __name__ == '__main__':
    unittest.main()
